//     The Brookshear Machine
//     Copyright (C) 2004 E. Rogan Creswick
//
//     This program is free software; you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation; either version 2 of the License, or
//     (at your option) any later version.
//
//     This program is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
//
//     You should have received a copy of the GNU General Public License
//     along with this program; if not, write to the Free Software
//     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/**
 *
 *
 *		AboutDialog.java
 *
 *	Last modified: 2/3/2000, 2:46 PM by: Rogan
 *
 *  2/3/00 - File created, creates a dialog box with information about
 *			the authors, Glenn Brookshear ( languge creator ) and other general info.
 *  6/18/04  ERC  Re-formatted the code, added a few comments.
 */

import java.awt.*;
import java.awt.event.*;

public class AboutDialog extends Dialog{
    private Frame parentFrame;
    
    TextArea mainArea = new TextArea("     A Typical Machine Language Compiler\n\n\tWritten by:\n       Stacy Brock\n       Rogan Creswick\n       Gary Hertel\n\n     A Typical Machine Language created by J. Glenn Brookshear, Marquette University.  The language can be found in _Computer_Scienc:_An_Overview_, by J. Glenn Brookshear.",0,0,TextArea.SCROLLBARS_VERTICAL_ONLY);
    
    Panel southPanel = new Panel();
    
    Button okButton = new Button("Ok");


    public AboutDialog(Frame parent){
	super(parent,"About");
	parentFrame = parent;
	
	
	// this window listener enables the "x" button to close the window.
	addWindowListener(new WindowAdapter(){public void windowClosing(WindowEvent e){e.getWindow().dispose();}});

	//this.setBounds(parentFrame.getBounds().x + parentFrame.getBounds().width/3,parentFrame.getBounds().y + parentFrame.getBounds().height/3
	//	,parentFrame.getBounds().width/3,parentFrame.getBounds().height/3);

	// Here we set the size of the dialog window to be 1/3 the size of the "main" applet window.
	this.setBounds(parentFrame.getBounds().x + parentFrame.getBounds().width/3,
		       parentFrame.getBounds().y + parentFrame.getBounds().height/3,
		       320,
		       parentFrame.getBounds().height/3);


	initWidgits();
	setColor();

	okButton.requestFocus();
    }// end AboutDialog()

    private void initWidgits(){
	mainArea.setEditable(false);

	setLayout(new BorderLayout());
	southPanel.setLayout(new FlowLayout());

	southPanel.add(okButton);
	add(mainArea, "Center");
	add(southPanel, "South");

	okButton.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    if((e.getActionCommand()).equals("Ok")){
			dispose();
		    }
		}
	    }// end inner-annonomous actionListener class
				   );

    }// end initWidgits()

    private void setColor(){
	mainArea.setBackground(OurColors.fieldBack);
	mainArea.setForeground(OurColors.fieldFore);

	okButton.setBackground(OurColors.buttonBack);
	okButton.setForeground(OurColors.buttonFore);

	southPanel.setBackground(OurColors.outer);
    }// end setColor()

}// end class AboutDialog