//     The Brookshear Machine
//     Copyright (C) 2004 E. Rogan Creswick
//
//     This program is free software; you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation; either version 2 of the License, or
//     (at your option) any later version.
//
//     This program is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
//
//     You should have received a copy of the GNU General Public License
//     along with this program; if not, write to the Free Software
//     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


//
//  Changelog:
// -------------------------------
//  ??-??-??    ERC   File created
//  06-21-04    ERC   Commented (slightly)
//                    GPL header added
//                    Code formatted

/**
 *  @class CompilerThread
 *
 *  This thread manages the actual execution of the machine code
 *  entered by the user.
 */
public class CompilerThread extends Thread{
    public CompilerThread(){
	//
    } // end of CompilerThread constructor

    public void run(){
	System.out.println("CompilerThread.run()");
	do{
	    Commands.step();
	    try{
		this.sleep(Globals.sleepTime);
	    }catch(InterruptedException e){}
			
	    System.out.println("Delay passed");
	    if ( !Globals.isThreaded ){
		if (Globals.programRunner == null)
		    return;
		Commands.stop();				
	    }
	}while(Globals.isRunning);
    } // end run()

} // end class CompilerThread
