/**
* HelpSystem.java
*
* Last edited on 3/11/2000 at 6:39 PM by Rogan Creswick
*
* Revision history:
*
* 3/11/00 - file created, pulled from CompilerGUI to simplify codeing.
*
*/

import java.awt.*;
import java.awt.event.*;

public class HelpSystem extends Panel{

    Panel helpPanel			= new Panel(); // help system Panel
    TabPanel helpTabPanel	= new TabPanel();

    public HelpSystem(){
	
	GridBagLayout miniBag = new GridBagLayout();
	GridBagConstraints miniConstraints = new GridBagConstraints();

	Panel commandPanel 	= new Panel();
	Panel aboutPanel	= new Panel();
	Panel compilerPanel	= new Panel();

	aboutPanel.setLayout(new BorderLayout());
	//commandPanel.setLayout(new BorderLayout());

	//**************************
	//  fill panels here

	commandPanel.setLayout(new BorderLayout());
	TextArea commandArea = new TextArea("\tOperand Codes\n\n"
					    + "1: RXY: Load the register R with the bit pattern found in the memory\n    cell whose address is XY\n"
					    + "2: RXY: Load the register R with the bit pattern XY\n"
					    + "3: RXY: Store the bit pattern found in register R in the memory cell\n    whose address is XY\n"
					    + "4: 0RS: Move the bit pattern found in register R to register S\n"
					    + "5: RST: Add the bit pattern found in register S and T as though they\n    were two's complement representations and leave the result in\n    register R\n"
					    + "6: RST: Add the bit patterns in registers S and T as though they\n    represented values in the floating-point notation and leave the\n    floating point result in register R\n"
					    + "7: RST: Or the bit patterns in registers S and T and place the result\n    in register R\n"
					    + "8: RST: And the bit patterns in register S and T and place the result\n    in register R\n"
					    + "9: RST: Exclusive Or the bit patterns in registers S and T and place\n    the result in register R\n"
					    + "A: R0X: Rotate the bit pattern in register R one bit to the right X times.\n    Each time place the bit that started at the low-order end at the\n    high order end\n"
					    + "B: RXY: Jump to the instruction located in the memory cell at\n    address XY if the bit pattern in register R is equal to the bit\n    pattern in register number 0. Otherwise, continue with the\n    normal sequence of execution.\n"
					    + "C: Halt execution\n"
					    + "D: RXY: Jump to the instruction located in the memory cell at\n"
					    +"    address XY if the bit pattern in register R is greater than the bit\n"
					    +"    pattern in register number 0. Otherwise, continue with the\n"
					    +"    normal sequence of execution. Comparisons are made in two's compliment\n");
		
	compilerPanel.setLayout(new BorderLayout());
	TextArea compilerArea = new TextArea("\tCompiler Information\n\n"
					     + "Run Button: Runs through the program at the speed of the slider.\n"
					     + "Step Button: Press to go through the program one step at a time.\n"
					     + "Stop Button: Stops the program from running. Required for both the\n\tStep and Run buttons.\n\n"
					     + "Matrix and List Modes\n"
					     + "List Mode: Allows you to comment the program or view the default comments.\n"
					     + "Matrix Mode: Lets you view all the registers at once.\n"
					     + "");
		
	TextArea aboutArea = new TextArea("     A Typical Machine Language Compiler\n\n"
					  + "\tWritten by:\n\n"
					  + "\tStacy Brock\n"
					  + "\tRogan Creswick\n"
					  + "\tGary Hertel\n\n"
					  + "     A Typical Machine Language created by J. Glenn Brookshear, Marquette University.  The language can be found in _Computer_Scienc:_An_Overview_, by J. Glenn Brookshear.",0,0,TextArea.SCROLLBARS_VERTICAL_ONLY);


	commandPanel.add(commandArea, "Center");
	compilerPanel.add(compilerArea, "Center");
	aboutPanel.add(aboutArea, "Center");
	//
	//**************************

	helpTabPanel.add("Commands",commandPanel);
	helpTabPanel.add("Compiler",compilerPanel);
	helpTabPanel.add("About",aboutPanel);

	//miniHelpTopPanel.setLayout(miniBag);
	this.setLayout(new BorderLayout());

	helpPanel.setLayout(new BorderLayout());
	helpPanel.setVisible(false);

	this.add(helpPanel,"Center");

	helpPanel.setBackground(OurColors.outerBackground);
	this.setBackground(OurColors.outerBackground);
	//miniHelpTopPanel.setBackground(OurColors.outerBackground);

    }// end initHelp();

    public void show(String panel){
	if(!Globals.helpShowing){
	    showHelp();
	    helpTabPanel.show(panel);
	}else if(Globals.helpShowing){
	    helpTabPanel.show(panel);
	}
    }// end show();
    
    public void showHelp(){
    
	if(!Globals.helpShowing){
	    
	    helpPanel.setVisible(true);
	    helpPanel.add(helpTabPanel,"Center");
	}else if(Globals.helpShowing){
	    helpPanel.remove(helpTabPanel);
	    helpPanel.setVisible(false);
	}

	//helpPanel.setVisible(!Globals.helpShowing);
	Globals.helpShowing = !Globals.helpShowing;
	GridBagConstraints miniConstraints = new GridBagConstraints();

	miniConstraints.gridx = 0;
	miniConstraints.gridy = 0;
	miniConstraints.anchor = GridBagConstraints.NORTHWEST;
	miniConstraints.weightx = 0;
	miniConstraints.weighty = 0;

	Globals.rootObj.validate();
    }// end showHelp();

}// end class HelpSystem
