/**
*
*		Highlight
* Last edited: 1/30/2000, 12:52 AM by Rogan
*
* Revision history:
*
* 1/22/00 - file created
*
* 1/30/00 - Added conditional to test for result of conditional jump
*			so the target of jump is highlighted only if it evalutates
*			to true.
*
**/

public class Highlight
{
	static int instruction1, instruction2, instruction3, instruction4;
	static int reg1, reg2, reg3, mem1, mem2;
	public static void highlight(int MemoryLocation)
	{
		mem2 = MemoryLocation * 2;
		Globals.memoryAddressLabels[MemoryLocation].setBackground(OurColors.memoryAddressLabelsBackHighlight);
		Globals.matrixFields[mem2].setBackground(OurColors.memoryAddressLabelsBackHighlight);
		Globals.matrixFields[mem2+1].setBackground(OurColors.memoryAddressLabelsBackHighlight);
		instruction1 = Globals.MemoryAddress[MemoryLocation * 4];
		instruction2 = Globals.MemoryAddress[MemoryLocation * 4 + 1];
		instruction3 = Globals.MemoryAddress[MemoryLocation * 4 + 2];
		instruction4 = Globals.MemoryAddress[MemoryLocation * 4 + 3];
		if (instruction1 == -1)
			instruction1 = 0;
		if (instruction2 == -1)
			instruction2 = 0;
		if (instruction3 == -1)
			instruction3 = 0;
		if (instruction4 == -1)
			instruction4 = 0;
		
		switch(instruction1)
		{
			case 1:		LoadAddress();
						break;
			case 2:		Load();
						break;
			case 3:		Store();
						break;
			case 4:		Move();
						break;
			case 5:		Add();
						break;
			case 6:		AddFloat();
						break;
			case 7:		Or();
						break;
			case 8:		And();
						break;
			case 9:		ExclusiveOr();
						break;
			case 10:	Rotate();
						break;
			case 11:	Jump();
						break;
			case 12:	Halt();
						break;
			default:	break;
		}
	}

	public static void unHighlight()
	{
		// reset memory list colors
		Globals.memoryAddressLabels[mem2/2].setBackground(OurColors.memoryAddressLabelsBack);
		Globals.memoryAddressLabels[mem1/2].setBackground(OurColors.memoryAddressLabelsBack);
		// reset matrix colors
		Globals.matrixFields[mem1].setBackground(OurColors.inputFieldsBack);
		Globals.matrixFields[mem1+1].setBackground(OurColors.inputFieldsBack);
		Globals.matrixFields[mem2].setBackground(OurColors.inputFieldsBack);
		Globals.matrixFields[mem2+1].setBackground(OurColors.inputFieldsBack);
		// reset register colors
		Globals.registerLabels[reg1].setBackground(OurColors.registerLabelsBack);
		Globals.registerLabels[reg2].setBackground(OurColors.registerLabelsBack);
		Globals.registerLabels[reg3].setBackground(OurColors.registerLabelsBack);
	}

	// Operand Code 1: RXY: Load the register R with the bit pattern found in the memory cell whose address is XY
	public static void LoadAddress()
	{
		mem1 = (instruction3 << 4) + instruction4;
		reg1 = instruction2;
		Globals.registerLabels[instruction2].setBackground(OurColors.registerLabelsBackHighlight);
		Globals.memoryAddressLabels[mem1/2].setBackground(OurColors.memoryAddressLabelsBackHighlight);
		Globals.matrixFields[mem1].setBackground(OurColors.memoryAddressLabelsBackHighlight);
		Globals.matrixFields[mem1+1].setBackground(OurColors.memoryAddressLabelsBackHighlight);
	}

	// Operand Code 2: RXY: Load the register R with the bit pattern XY
	public static void Load()
	{
		reg1 = instruction2;
		Globals.registerLabels[instruction2].setBackground(OurColors.registerLabelsBackHighlight);
	}

	// Operand Code 3: RXY: Store the bit pattern found in register R in the memory cell whose address is XY
	public static void Store()
	{
		mem1 = (instruction3 << 4) + instruction4;
		reg1 = instruction2;
		Globals.registerLabels[instruction2].setBackground(OurColors.registerLabelsBackHighlight);
		Globals.memoryAddressLabels[mem1/2].setBackground(OurColors.memoryAddressLabelsBackHighlight);
		Globals.matrixFields[mem1].setBackground(OurColors.memoryAddressLabelsBackHighlight);
		Globals.matrixFields[mem1+1].setBackground(OurColors.memoryAddressLabelsBackHighlight);
	}

	// Operand Code 4: 0RS: Move the bit pattern found in register R to register S
	public static void Move()
	{
		reg1 = instruction3;
		reg2 = instruction4;
		Globals.registerLabels[instruction3].setBackground(OurColors.registerLabelsBackHighlight);
		Globals.registerLabels[instruction4].setBackground(OurColors.registerLabelsBackHighlight);
	}

	// Operand Code 5: RST: Add the bit pattern found in register S and T as though they were two's complement representations and leave the result in register R
	public static void Add()
	{
		reg1 = instruction2;
		reg2 = instruction3;
		reg3 = instruction4;
		Globals.registerLabels[instruction2].setBackground(OurColors.registerLabelsBackHighlight);
		Globals.registerLabels[instruction3].setBackground(OurColors.registerLabelsBackHighlight);
		Globals.registerLabels[instruction4].setBackground(OurColors.registerLabelsBackHighlight);
	}

	// Operand Code 6: RST: Add the bit patterns in registers S and T as though they represented values in the floatin-point notation and leave the floating point result in register R
	public static void AddFloat()
	{
		reg1 = instruction2;
		reg2 = instruction3;
		reg3 = instruction4;
		Globals.registerLabels[instruction2].setBackground(OurColors.registerLabelsBackHighlight);
		Globals.registerLabels[instruction3].setBackground(OurColors.registerLabelsBackHighlight);
		Globals.registerLabels[instruction4].setBackground(OurColors.registerLabelsBackHighlight);
	}

	// Operand Code 7: RST: Or the bit patterns in registers S and T and place the result in register R
	public static void Or()
	{
		reg1 = instruction2;
		reg2 = instruction3;
		reg3 = instruction4;
		Globals.registerLabels[instruction2].setBackground(OurColors.registerLabelsBackHighlight);
		Globals.registerLabels[instruction3].setBackground(OurColors.registerLabelsBackHighlight);
		Globals.registerLabels[instruction4].setBackground(OurColors.registerLabelsBackHighlight);
	}

	// Operand Code 8: RST: And the bit patterns in register S and T and place the result in register R
	public static void And()
	{
		reg1 = instruction2;
		reg2 = instruction3;
		reg3 = instruction4;
		Globals.registerLabels[instruction2].setBackground(OurColors.registerLabelsBackHighlight);
		Globals.registerLabels[instruction3].setBackground(OurColors.registerLabelsBackHighlight);
		Globals.registerLabels[instruction4].setBackground(OurColors.registerLabelsBackHighlight);
	}

	// Operand Code 9: RST: Exclusive Or the bit patterns in registers S and T and place the result in register R
	public static void ExclusiveOr()
	{
		reg1 = instruction2;
		reg2 = instruction3;
		reg3 = instruction4;
		Globals.registerLabels[instruction2].setBackground(OurColors.registerLabelsBackHighlight);
		Globals.registerLabels[instruction3].setBackground(OurColors.registerLabelsBackHighlight);
		Globals.registerLabels[instruction4].setBackground(OurColors.registerLabelsBackHighlight);
	}

	// Operand Code A: R0X: Rotate the bit pattern in register R one bit to the right X times.  Each time place the bit that started at the low-order end at the high order end
	public static void Rotate()
	{
		reg1 = instruction2;
		Globals.registerLabels[instruction2].setBackground(OurColors.registerLabelsBackHighlight);
		Globals.registerLabels[instruction4].setBackground(OurColors.registerLabelsBackHighlight);
	}

	// Operand Code B: RXY: Jump to the instruction located in the memory cell at address XY if the bit pattern in register R is equal to the bit pattern in register number 0. Otherwise, continue with the normal sequence of execution.
	public static void Jump()
	{
		mem1 = (instruction3 << 4) + instruction4;
		reg1 = instruction2;
		reg2 = 0;
		Globals.registerLabels[instruction2].setBackground(OurColors.registerLabelsBackHighlight);
		Globals.registerLabels[0].setBackground(OurColors.registerLabelsBackHighlight);
		// if the conditional is true, then highlight the destination.
		if(Globals.RegisterAddress[2 * instruction2] == Globals.RegisterAddress[0] 
		   && Globals.RegisterAddress[2 * instruction2 + 1] == Globals.RegisterAddress[1])
		{
			Globals.memoryAddressLabels[mem1/2].setBackground(OurColors.memoryAddressLabelsBackHighlight);
			Globals.matrixFields[mem1].setBackground(OurColors.memoryAddressLabelsBackHighlight);
			Globals.matrixFields[mem1+1].setBackground(OurColors.memoryAddressLabelsBackHighlight);
		}
	}

	// Operand Code C: Halt execution
	public static void Halt()
	{
	}
}