/**
*
*		IO Dialog
* Last edited: 1/30/2000, 1:15 AM by Rogan
*
* Revision history:
*
* 1/21/00 - history started.
* 1/29/00 - removed done button, changed cancel to close
*			import/export buttons now close window also.
*           'x' in corner of window closes it now.
* 10/03/02 - Rearranged the components to waste less screen space.
*
**/

import java.awt.*;
import java.awt.event.*;

public class IODialog extends Dialog
{
	private ActionGrabber actionHandler = new ActionGrabber();

	private TextArea ioArea = new TextArea();

	private Panel buttonPanel  = new Panel();
	private Panel buttonPanel2 = new Panel();
	private Panel ioPanel	   = new Panel();
	private Panel cancelPanel  = new Panel();

	private Button exporter = new Button("Export");
	private Button importer = new Button("Import");
	private Button close	= new Button("Close");

	private Label areaLabel = new Label("Import/Export");

	private Frame owner;

	private void setColor()
	{
		buttonPanel.setBackground(OurColors.outer);
		buttonPanel.setForeground(OurColors.titles);
		buttonPanel2.setBackground(OurColors.outer);
		buttonPanel2.setForeground(OurColors.titles);
		ioPanel.setBackground(OurColors.outer);
		ioPanel.setForeground(OurColors.titles);
		cancelPanel.setBackground(OurColors.outer);
		cancelPanel.setForeground(OurColors.titles);

		exporter.setBackground(OurColors.buttonBack);
		exporter.setForeground(OurColors.buttonFore);
		importer.setBackground(OurColors.buttonBack);
		importer.setForeground(OurColors.buttonFore);
		close.setBackground(OurColors.buttonBack);
		close.setForeground(OurColors.buttonFore);

		areaLabel.setBackground(OurColors.outer);
		areaLabel.setForeground(OurColors.titles);
		ioArea.setBackground(OurColors.fieldBack);
		ioArea.setForeground(OurColors.fieldFore);

	}// end setColors()

	public IODialog(Frame towner)
	{
		super(towner);
		this.owner = towner;

		addWindowListener(new WindowAdapter(){public void windowClosing(WindowEvent e){e.getWindow().dispose();}});
		
		setResizable(true);

		initWidgits();
		addActionStuff();
	}// end IODialog()

	private void initWidgits()
	{
	    setColor();
	    setLayout(new BorderLayout());
	    ioPanel.setLayout(new BorderLayout());
	    cancelPanel.setLayout(new BorderLayout());
	    
	    //		buttonPanel2.add(close);
	    cancelPanel.add(buttonPanel2,"South");
	    cancelPanel.add(areaLabel,"Center");
	    buttonPanel.add(importer);
	    buttonPanel.add(exporter);
	    buttonPanel.add(close);
	    
	    ioPanel.add(areaLabel, "North");
	    ioPanel.add(ioArea, "Center");
	    ioPanel.add(buttonPanel, "South");
	    
	    add(ioPanel,"Center");
	    
	    add(cancelPanel, "East");
	    
	}// end initWidgits()

	public void ioPort()
	{
		this.show();
	}// end ioPort()

	private void closeWin()
	{
		ioArea.setText("");
		this.dispose();
	}// end closeWin()

	private void exportCode()
	{
		ioArea.setText(Globals.findCode());

	}// end exportCode()

	private void importCode()
	{
		//System.out.println(ioArea.getColumns());
		Commands.getInput(ioArea.getText());
		Globals.updateTextfields();
		closeWin();
	}// end importCode()

	private void addActionStuff()
	{
		close.addActionListener( actionHandler );
		importer.addActionListener( actionHandler );
		exporter.addActionListener( actionHandler );

	}// end addActionStuff()


	class ActionGrabber implements ActionListener
	{
		public void actionPerformed(ActionEvent e)
		{
			String command = e.getActionCommand();

			if( command.equals("Close"))
			{
				System.out.println("IODialog -> Close pressed");
				closeWin();
			}
			else if( command.equals("Export"))
			{
				System.out.println("IODialog -> Export pressed");
				exportCode();
			}
			else if( command.equals("Import"))
			{
				System.out.println("IODialog -> Import pressed");
				importCode();
			}

		}// end ActionPerformed()

	}// end inner class ActionGrabber



}// end class IODialog
