/**
*
*		Output
* Last edited: 2/13 by Gary Hertel
*
* Revision history:
*
* 1/21/00 - history started.
*
* 1/31/00 - changed the output from setting a string and then setting label to 
* string to just setting the label with the string in the first place.
*
* 2/13 - changed the output to work work the matrix
*
**/

public class Output
{
	public static void displayOutputText(int location)
	{
		int instruction1 = Globals.MemoryAddress[4*location];
		char instruction2 = Globals.toHex(Globals.MemoryAddress[4*location + 1]).charAt(0);
		char instruction3 = Globals.toHex(Globals.MemoryAddress[4*location + 2]).charAt(0);
		char instruction4 = Globals.toHex(Globals.MemoryAddress[4*location + 3]).charAt(0);

		if (instruction2 == '-')
			instruction2 = '?';
		if (instruction3 == '-')
			instruction3 = '?';
		if (instruction4 == '-')
			instruction4 = '?';
		
		int MemoryLocation = location;
		String outputString;
		switch(instruction1)
		{
		case 1:		outputString = "Load register " + instruction2 + " with bit pattern found at " + instruction3 + instruction4;
		    break;
		case 2:		outputString = "Load register " + instruction2 + " with bit pattern " + instruction3 + instruction4;
		    break;
		case 3:		outputString = "Store bit pattern from register " + instruction2 + " at address " + instruction3 + instruction4;
		    break;
		case 4:		outputString = "Move bit pattern from register " + instruction2 + " to register " + instruction3;
		    break;
		case 5:		outputString = "Add bit patterns in registers " + instruction3 + " and " + instruction4 + " as two's complement, store result in register " + instruction2;
		    break;
		case 6:		outputString = "Add bit patterns in registers " + instruction3 + " and " + instruction4 + " as floating point numbers, store result in register " + instruction2;
		    break;
		case 7:		outputString = "OR the bit patterns in registers " + instruction3 + " and " + instruction4 + " and store result in register " + instruction2;
		    break;
		case 8:		outputString = "AND the bit patterns in registers " + instruction3 + " and " + instruction4 + " and store result in register " + instruction2;
		    break;
		case 9:		outputString = "XOR the bit patterns in registers " + instruction3 + " and " + instruction4 + " and store result in register " + instruction2;
		    break;
		case 10:	outputString = "Rotate the bit pattern in register " + instruction2 + " to the right " + instruction4 + " times";
		    break;
		case 11:	outputString = "If bit pattern in register " + instruction2 + " equals the value in register 0, jump to location " + instruction3 + instruction4;
		    break;
		case 12:	outputString = "Halt execution";
		    break;
		case 13:        outputString = "If bit pattern in register " + instruction2 + " is greater than the value in register 0, jump to location " + instruction3 + instruction4;
		    break;
		default:	outputString = "";
		    break;
		}
		if (Globals.matrixShowing)
		{
			Globals.bottomOutputField.setForeground(OurColors.bottomOutputFieldFore);
			Globals.bottomOutputField.setText(outputString);
		}
		else
			Globals.outputLabels[MemoryLocation].setText(outputString);
	}
}
