/**
 * Prefrences Dialog
 * By: E. Rogan Creswick
 *
 * This is a simple PrefrencesDialog for Compiler.
 *
 * Last updated:  4/29/00  7:08 pm  By Rogan Creswick
 *
 * History:
 * ??/??/??  -file created.
 * 4/29/00   -basically re-created file. it Now toggles 3 booleans in Globals depending on user input.
 */

import java.awt.*;
import java.awt.event.*;

public class PreferencesDialog extends Dialog
{
	Panel boxes				= new Panel();
	Panel labels			= new Panel();
	
	Label haltLbl			= new Label("Hald on errors.");
	Label shiftLbl			= new Label("Shift memory cells on insert/delete.");
	Label backupLbl		= new Label("Backup code before running.");	
	
	Checkbox haltBox 		= new Checkbox(null);
	Checkbox shiftBox 	= new Checkbox(null,true);
	Checkbox backupBox	= new Checkbox(null);
	
	public PreferencesDialog(Frame parent)
	{
		super(parent);
      this.setTitle("Preferences Dialog");
		this.setBounds(parent.getBounds().x+parent.getBounds().width / 3,parent.getBounds().x+parent.getBounds().height / 4,
			parent.getBounds().width/3+20, parent.getBounds().height/5);
		addWindowListener(new WindowAdapter(){public void windowClosing(WindowEvent e){e.getWindow().dispose();}});
	}// end PreferencesDialog()

	public void displayDialog()
	{

		initWidgits();
		drawWidgits();
		addActionStuff();

		this.show();
	}// end displayDialog()

	private void initWidgits()
	{
      this.setBackground(OurColors.outer);
      haltLbl.setForeground(OurColors.titles);
      shiftLbl.setForeground(OurColors.titles);
      backupLbl.setForeground(OurColors.titles);
	}// end initWidgits()


	private void drawWidgits()
	{
		this.setLayout(new BorderLayout());
	   boxes.setLayout(new GridLayout(3,1));
	   labels.setLayout(new GridLayout(3,1));
	
	   boxes.add(haltBox);
	   boxes.add(shiftBox);
	   boxes.add(backupBox);
	
	   labels.add(haltLbl);
	   labels.add(shiftLbl);
	   labels.add(backupLbl);
	
	   this.add(boxes, "West");
	   this.add(labels, "Center");
	}// end drawWidgits()

	private void addActionStuff()
	{
		haltBox.addItemListener(new ItemGrabber("Halt"));
		shiftBox.addItemListener(new ItemGrabber("Shift"));
		backupBox.addItemListener(new ItemGrabber("Backup"));	
	}// end addActionStuff()

   class ItemGrabber implements ItemListener
   {
   	String name;

   	public ItemGrabber(String name)
   	{
   		this.name = name;
   	}
   	public void itemStateChanged(ItemEvent e)
   	{
   		Checkbox temp = (Checkbox)e.getItemSelectable();
   	
   		if(name.equals("Halt"))
   		{
   			System.out.println("Halt on Errors toggled.");
   		 	Globals.haltOnErrors = temp.getState();
   		}
   		if(name.equals("Shift"))
   		{
   		   System.out.println("shifting toggled.");
   			Globals.shiftOn = temp.getState();
   		}
   		if(name.equals("Backup"))
   		{
   			System.out.println("Backup code toggled.");   		
   			Globals.backupCode = temp.getState();
   		}
   	}
   }

}// end class PrefrencesDialog